#include <iarduino_Pressure_BMP.h>              // Подключаем библиотеку для работы с датчиками давления BMP180 или BMP280.
#include <iarduino_4LED.h>                      // Подключаем библиотеку для работы с Trema LED индикатором.
                                                //
iarduino_4LED         display(2,3);             // Объявляем объект display для работы с LED индикатором, указывая выводы подключения индикатора ( CLK , DIO ).
iarduino_Pressure_BMP sensor;                   // Объявляем объект sensor для работы с датчиком давления адрес которого на шине I2C установлен по умолчанию.
const uint8_t         pinKey = 12;              // Определяем константу с указанием вывода Arduino к которому подключена кнопка сброса высоты.
const float           average = 100;            // Определяем константу усреднения показаний датчика (чем выше значение, тем выше инерционность выводимых показаний).
float                 altitude;                 // Объявляем переменную для хранения выводимой высоты.
                                                //
void setup(){                                   //
    pinMode(pinKey,INPUT);                      // Конфигурируем вывод кнопки как вход
    delay(1000);                                // Устанавливаем задержку для стабилизации показаний датчика давления после включения питания.
    sensor.begin();                             // Инициируем работу с датчиком (начальная высота по умолчанию = 0 метров).
    display.begin();                            // Инициируем работу с LED индикатором.
    display.light(5);                           // Устанавливаем яркость LED индикатора.
    sensor.read();                              // Читаем данные с датчика давления.
    altitude=sensor.altitude;                   // Сохраняем прочитанную высоту.
}                                               //
                                                //
void loop(){                                    //
    sensor.read();                              // Читаем данные с датчика давления.
    altitude *= average-1;                      // Умножаем предыдущее значение высоты на коэффициент усреднения-1.
    altitude += sensor.altitude;                // Добавляем к полученному значению новые показания высоты.
    altitude /= average;                        // Делим полученное значение на коэффициент усреднения.
    display.print(altitude,1);                  // Выводим полученное значение на LED индикатор, число с одним знаком после запятой.
    if(digitalRead(pinKey)){                    // Если нажата кнопка, то ...
        while(digitalRead(pinKey)){delay(100);} // Входим в цикл пока кнопка не будет отпущена. Задержка delay(100) подавляет дребезг при нажатии кнопки
        sensor.begin(0);           delay(100);  // Сбрасываем высоту в 0 метров.                Задержка delay(100) подавляет дребезг при отпускании кнопки
    }                                           //
}                                               //
